package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.WFAssistWork;
import com.sa.ibiz.demo.demo.service.WFAssistWorkService;
import com.sa.ibiz.demo.demo.service.dto.WFAssistWorkSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/wfassistwork")
public class WFAssistWorkResource
{
	@Autowired
	private WFAssistWorkService service;


	@PostMapping(value = "/update")
	public ResponseEntity<WFAssistWork> update(@Validated @RequestBody WFAssistWork data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流代办工作[update]操作发生错误","WFAssistWork",data.getWfassistworkid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<WFAssistWork> get(@Validated @PathVariable String id){
		WFAssistWork data=new WFAssistWork();
		data.setWfassistworkid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("工作流代办工作[get]操作发生错误","WFAssistWork",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<WFAssistWork> remove(@Validated @RequestBody WFAssistWork data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流代办工作[remove]操作发生错误","WFAssistWork",data.getWfassistworkid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<WFAssistWork> checkKey(@Validated @RequestBody WFAssistWork data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流代办工作[checkKey]操作发生错误","WFAssistWork",data.getWfassistworkid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<WFAssistWork> create(@Validated @RequestBody WFAssistWork data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流代办工作[create]操作发生错误","WFAssistWork",data.getWfassistworkid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<WFAssistWork> getDraft(@Validated @RequestBody WFAssistWork data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流代办工作[getDraft]操作发生错误","WFAssistWork","");
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchcuruserassistwork")
	public ResponseEntity<Page<WFAssistWork>> searchCurUserAssistWorkPage(@Validated @RequestBody WFAssistWorkSearchFilter filter){
		Page<WFAssistWork> searchResult = service.searchCurUserAssistWork(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listcuruserassistwork")
	public ResponseEntity<List<WFAssistWork>> listCurUserAssistWork(@Validated @RequestBody WFAssistWorkSearchFilter filter){
		List<WFAssistWork> searchResult = service.listCurUserAssistWork(filter);
		return ResponseEntity.ok().body(searchResult);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<WFAssistWork>> searchDefaultPage(@Validated @RequestBody WFAssistWorkSearchFilter filter){
		Page<WFAssistWork> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<WFAssistWork>> listDefault(@Validated @RequestBody WFAssistWorkSearchFilter filter){
		List<WFAssistWork> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
